# -*- coding: utf-8 -*-
"""
Created on Thu May  4 22:41:26 2023

@author: zhang lanxin
"""

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import datetime as dt
import seaborn as sns
from sklearn.preprocessing import StandardScaler
from sklearn.pipeline import Pipeline
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import OneHotEncoder
from sklearn.preprocessing import LabelBinarizer
from sklearn.preprocessing import LabelEncoder
from sklearn.metrics import confusion_matrix, classification_report, f1_score
import xgboost as xgb
import os

#X
X = pd.read_csv('Features-Intersection.csv')
X =X[['angle','Acceleration']]

#Y
Y = pd.read_csv('Abnormal-Intersection.csv')


########
'''
#Sometimes no standardscaler is better for the classifciation result
'''
from sklearn.preprocessing import Normalizer, MinMaxScaler

X_train, X_test,  y_train, y_test = train_test_split(X, Y, test_size=0.2, random_state=24)

standS = StandardScaler().fit(X_train)
#standS = MinMaxScaler().fit(X_train)
X_train_std = standS.fit_transform(X_train)
X_test_std = standS.fit_transform(X_test)


import itertools

# Create a confusion matrix
def plot_confusion_matrix(cm, classes,
                          normalize=False,
                          title='Confusion matrix',
                          cmap=plt.cm.Blues):
    """
    This function prints and plots the confusion matrix.
    Normalization can be applied by setting `normalize=True`.
    """
    if normalize:
        cm = cm.astype('float') / cm.sum(axis=1)[:, np.newaxis]
        print("Normalized confusion matrix")
    else:
        print('Confusion matrix, without normalization')

    print(cm)

    plt.imshow(cm, interpolation='nearest', cmap=cmap)
    plt.title(title, fontsize=14)
    plt.colorbar()
    tick_marks = np.arange(len(classes))
    plt.xticks(tick_marks, classes, rotation=45)
    plt.yticks(tick_marks, classes)

    fmt = '.2f' if normalize else 'd'
    thresh = cm.max() / 2.
    for i, j in itertools.product(range(cm.shape[0]), range(cm.shape[1])):
        plt.text(j, i, format(cm[i, j], fmt),
                 horizontalalignment="center",
                 color="white" if cm[i, j] > thresh else "black")

    plt.tight_layout()
    plt.ylabel('True label')
    plt.xlabel('Predicted label')

#
normal_index  =  np.array( Y == 0 )
abnormal_index = np.array( Y != 0 )
X_normal = X[normal_index]
X_outliers = X[abnormal_index]
y_normal = Y[normal_index]
y_outliers = Y[abnormal_index]

X_normal_train, X_normal_valid,  y_normal_train, y_normal_valid = train_test_split(X_normal, y_normal, test_size=0.16, random_state=24)
X_val =  pd.concat([X_normal_valid, X_outliers], axis=0)
map_v = {0:1, 1:-1}

y_val_v =  pd.concat([y_normal_valid, y_outliers], axis=0)
y_val_v1 = y_val_v['Label'].map(map_v)
y_trian_try = y_normal_train['Label'].map(map_v)
y_normal_valid_try = y_normal_valid['Label'].map(map_v)
y_all = Y['Label'].map(map_v)




# fit the model
from sklearn.ensemble import IsolationForest
import time
print('IsolationForest:')

rng = np.random.RandomState(39)
clf = IsolationForest(n_estimators = 10, max_samples= 'auto', random_state=rng, contamination= 'auto')

t = []
f1score = []
cm_record = []
classification_report_record = []
FPR_record = []
TPR_record = []
ACC_record = []

t0 = time.time()
clf.fit(X_normal_train)
t1 = time.time()
t_IsolationForest = t1 - t0
print("IsolationForest {:.3} s".format(t1 - t0))
t.append(t_IsolationForest)


y_pred_train = clf.predict(X_normal_train)
y_pred_valid = clf.predict(X_normal_valid)
y_pred_outliers = clf.predict(X_outliers)

n_error_train = y_pred_train[y_pred_train == -1].size
n_error_valid = y_pred_valid[y_pred_valid == -1].size
n_error_outliers = y_pred_outliers[y_pred_outliers == 1].size

n_error_train_rate = y_pred_train[y_pred_train == -1].size / y_pred_train.size
n_error_valid_rate = y_pred_valid[y_pred_valid == -1].size /y_pred_valid.size
n_error_outliers_rate = y_pred_outliers[y_pred_outliers == 1].size /y_pred_outliers.size

y_pred_val = clf.predict(X_val)

cm_v = confusion_matrix(y_val_v1, y_pred_val)
print(classification_report(y_val_v1, y_pred_val))

f1score.append(f1_score(y_val_v1, y_pred_val))

print('f1_score:')
print(f1_score(y_val_v1, y_pred_val))
print('~~~~~~~~~')

cm_record.append(cm_v)
classification_report_record.append(classification_report(y_val_v1, y_pred_val))

'''
Plot confusion matrix
'''
import itertools

# Create a confusion matrix
def plot_confusion_matrix(cm, classes,
                          normalize=False,
                          title='Confusion matrix',
                          cmap=plt.cm.Blues):
    """
    This function prints and plots the confusion matrix.
    Normalization can be applied by setting `normalize=True`.
    """
    if normalize:
        cm = cm.astype('float') / cm.sum(axis=1)[:, np.newaxis]
        print("Normalized confusion matrix")
    else:
        print('Confusion matrix, without normalization')

    print(cm)

    plt.imshow(cm, interpolation='nearest', cmap=cmap)
    plt.title(title, fontsize=14)
    plt.colorbar()
    tick_marks = np.arange(len(classes))
    plt.xticks(tick_marks, classes, rotation=45)
    plt.yticks(tick_marks, classes)

    fmt = '.2f' if normalize else 'd'
    thresh = cm.max() / 2.
    for i, j in itertools.product(range(cm.shape[0]), range(cm.shape[1])):
        plt.text(j, i, format(cm[i, j], fmt),
                 horizontalalignment="center",
                 color="white" if cm[i, j] > thresh else "black")

    plt.tight_layout()
    plt.ylabel('True label')
    plt.xlabel('Predicted label')
labels = ['Anomaly','Normal'] #labels = ['Leakage','No leakage']
fig = plt.figure(figsize=(11.963,9.3))
fig.add_subplot(211)
plot_confusion_matrix(cm_v, labels, title="Confusion Matrix---IsolationForest", cmap=plt.cm.Greens)
plt.savefig('IsolationForest-Int3.png',dpi=600)
# Fall out or false positive rate
#FPR = FP/(FP+TN)
FPR = cm_v[1][0] / (cm_v[1][0] + cm_v[1][1])
#TPR = TP /（TP + FN） 
TPR = cm_v[0][0] / (cm_v[0][0] + cm_v[0][1])
ACC = (cm_v[0][0] + cm_v[1][1]) / (cm_v[0][0] + cm_v[0][1] + cm_v[1][0] + cm_v[1][1])
FPR_record.append(FPR)
TPR_record.append(TPR)
ACC_record.append(ACC)
print('FPR:')
print(FPR)
print('TPR:')
print(TPR)
print('ACC:')
print(ACC)
f1_score(y_val_v1, y_pred_val)


'''
# LocalOutlierFactor
'''
from sklearn.neighbors import LocalOutlierFactor
LOF = LocalOutlierFactor(novelty=True)

print('LocalOutlierFactor:')

t0 = time.time()
LOF.fit(X_normal_train)
t1 = time.time()
t_LocalOutlierFactor = t1 - t0
print("LocalOutlierFactor {:.3} s".format(t1 - t0))

t.append(t_LocalOutlierFactor)
y_pred_train = LOF.predict(X_normal_train)
y_pred_valid = LOF.predict(X_normal_valid)
y_pred_outliers = LOF.predict(X_outliers)
n_error_train = y_pred_train[y_pred_train == -1].size
n_error_valid = y_pred_valid[y_pred_valid == -1].size
n_error_outliers = y_pred_outliers[y_pred_outliers == 1].size
n_error_train_rate = y_pred_train[y_pred_train == -1].size / y_pred_train.size
n_error_valid_rate = y_pred_valid[y_pred_valid == -1].size /y_pred_valid.size
n_error_outliers_rate = y_pred_outliers[y_pred_outliers == 1].size /y_pred_outliers.size
y_pred_val = LOF.predict(X_val)
cm_v = confusion_matrix(y_val_v1, y_pred_val)
print(classification_report(y_val_v1, y_pred_val))
print('f1_score:')
print(f1_score(y_val_v1, y_pred_val))
print('~~~~~~~~~')
f1score.append(f1_score(y_val_v1, y_pred_val))
cm_record.append(cm_v)
classification_report_record.append(classification_report(y_val_v1, y_pred_val))

FPR = cm_v[1][0] / (cm_v[1][0] + cm_v[1][1])
FPR_record.append(FPR)

#TPR = TP /（TP + FN） 
TPR = cm_v[0][0] / (cm_v[0][0] + cm_v[0][1])
ACC = (cm_v[0][0] + cm_v[1][1]) / (cm_v[0][0] + cm_v[0][1] + cm_v[1][0] + cm_v[1][1])
FPR_record.append(FPR)
TPR_record.append(TPR)
ACC_record.append(ACC)

print('FPR:')
print(FPR)
print('~~~~~~~~~')
print('TPR:')
print(TPR)
print('~~~~~~~~~')
print('ACC:')
print(ACC)
print('~~~~~~~~~')


fig = plt.figure(figsize=(11.963,9.3))
fig.add_subplot(212)
plot_confusion_matrix(cm_v, labels, title="Confusion Matrix---LocalOutlierFactor", cmap=plt.cm.Reds)
plt.savefig('LocalOutlierFactor-Int3.png',dpi=600)


'''
# Robust covariance
sklearn.covariance.EllipticEnvelope assumes the data is Gaussian and learns an ellipse. 
It thus degrades when the data is not unimodal. 
Notice however that this estimator is robust to outliers.
'''
from sklearn.covariance import EllipticEnvelope
RCE = EllipticEnvelope(contamination=0.17396393)

t0 = time.time()
RCE.fit(X_normal_train)
t1 = time.time()
t_RCE = t1 - t0
print("Robust covariance {:.3} s".format(t1 - t0))

t.append(t_RCE)

y_pred_train = RCE.predict(X_normal_train)
y_pred_valid = RCE.predict(X_normal_valid)
y_pred_outliers = RCE.predict(X_outliers)

n_error_train = y_pred_train[y_pred_train == -1].size
n_error_valid = y_pred_valid[y_pred_valid == -1].size
n_error_outliers = y_pred_outliers[y_pred_outliers == 1].size

n_error_train_rate = y_pred_train[y_pred_train == -1].size / y_pred_train.size
n_error_valid_rate = y_pred_valid[y_pred_valid == -1].size /y_pred_valid.size
n_error_outliers_rate = y_pred_outliers[y_pred_outliers == 1].size /y_pred_outliers.size

y_pred_val = RCE.predict(X_val)
cm_v = confusion_matrix(y_val_v1, y_pred_val)
print(classification_report(y_val_v1, y_pred_val))
print('f1_score:')
print(f1_score(y_val_v1, y_pred_val))
print('~~~~~~~~~')
f1score.append(f1_score(y_val_v1, y_pred_val))
cm_record.append(cm_v)
classification_report_record.append(classification_report(y_val_v1, y_pred_val))

FPR = cm_v[1][0] / (cm_v[1][0] + cm_v[1][1])
FPR_record.append(FPR)
#TPR = TP /（TP + FN） 
TPR = cm_v[0][0] / (cm_v[0][0] + cm_v[0][1])
ACC = (cm_v[0][0] + cm_v[1][1]) / (cm_v[0][0] + cm_v[0][1] + cm_v[1][0] + cm_v[1][1])

FPR_record.append(FPR)
TPR_record.append(TPR)
ACC_record.append(ACC)

print('FPR:')
print(FPR)
print('~~~~~~~~~')

print('TPR:')
print(TPR)
print('~~~~~~~~~')

print('ACC:')
print(ACC)
print('~~~~~~~~~')

fig = plt.figure(figsize=(11.963,9.3))
fig.add_subplot(222)
plot_confusion_matrix(cm_v, labels, title="Confusion Matrix---RobustCovariance", cmap=plt.cm.Purples)
plt.savefig('Robust covariance-Int3.png',dpi=600)